package com.eneraptor.hci

class ChooseHwSetController {

    def index = { }
	
	def main = {
		
		def hwSets = HardwareSet.list()
		
		[hwSets: hwSets]
		
	}
	
	def mainDo = {
		
		HardwareSet chosenHwSet = HardwareSet.get(params['hwSet'])
		
		if(chosenHwSet) {
			
			session['hwSet'] = chosenHwSet
			redirect(controller:'sysState',action:'main')
			return true
			
		}
		
		redirect(action:'main')
		return false
		
	}
	
	def addNew = { }
	
	def addNewDo = {
		
		HardwareSet newHwSet = new HardwareSet(params)
		
		if(!newHwSet.validate()) {
			redirect(action:'addNew',params:(params << ['invalid':true]))
			return false
		} else {
			newHwSet.save()
			redirect(action:main)
			return true
		}
		
	}
	
	def change = {
		
		def chosenHwSet = HardwareSet.get(params.id)
		
		if(chosenHwSet) {
			session['hwSet'] = chosenHwSet
			flash.confirms = "<p>Changed current hardware set to " + chosenHwSet.name + "</p>"
			redirect(controller:'sysState',action:'main')
			return true
		} else {
			flash.errors = "<p>Could not change current hardware set (card). The ID specified is not valid!</p>"
			redirect(controller:'sysState',action:'main')
		}
		
		return false
		
	}
	
	def delete = {
		
		def hwSet = HardwareSet.get(params['id'])
		
		if(hwSet) {
			
			session.hwSet = null
			hwSet.delete()
			redirect(action:'main')
			return true
			
		} else {
			flash.errors = '<p>Could not delete hardware set (card). The ID specified is invalid.</p>'
			redirect(controller:'config',action:'logic')
			return false
		}
		
	}
	
}
